From d00f49abf6a642a13b0536341b9f7611b7e238be Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Tue, 11 Apr 2023 12:02:00 +0700
Subject: [PATCH 09/13] Genlock support for FD788v2.

---
 forward-v4l2/forward-v4l2-fd788.c | 104 +++++++++++++++++++-----------
 1 file changed, 68 insertions(+), 36 deletions(-)

diff --git a/forward-v4l2/forward-v4l2-fd788.c b/forward-v4l2/forward-v4l2-fd788.c
index d86b292..91e550d 100644
--- a/forward-v4l2/forward-v4l2-fd788.c
+++ b/forward-v4l2/forward-v4l2-fd788.c
@@ -47,6 +47,8 @@
 #define FD788_YC_SWAP_REVISION 849
 #define FD788_ASI_PERIOD_REVISION 873
 
+#define FD788_IS_VERSION_2(ver) (((ver >> 24) & 0xF) >= 2)
+
 static void fd788_check_pll_configuration(struct forward_v4l2 *v4l2)
 {
 	FD788_ClockFrequency freq;
@@ -855,17 +857,20 @@ static s64 fd788_clock_deviation(struct forward_v4l2 *v4l2)
 static s64 fd788_set_clock_deviation(struct forward_v4l2 *v4l2, s64 ppt)
 {
 	struct forward_dev *dev = v4l2->dev;
-	FD788_ClockDeviation dv;
-	u64 value = ((ppt < 0) ? -ppt : ppt) * 2818578888ULL / 1000000000000ULL;
-
-	dv.deviation = (value > 1290555) ? 1290555 : value;
-	dv.direction = (ppt < 0) ? 1 : 0;
+	if (FD788_IS_VERSION_2(dev->fw_version)) {
+		return v4l2->dev->pll->ops->tune(v4l2->dev->pll, ppt);
+	} else {
+		FD788_ClockDeviation dv;
+		u64 value = ((ppt < 0) ? -ppt : ppt) * 2818572288ULL / 1000000000000ULL;
 
-	FD788_ClockDeviation_W(dev->csr, dv);
+		dv.deviation = (value > 1290555) ? 1290555 : value;
+		dv.direction = (ppt < 0) ? 1 : 0;
 
-	value = dv.deviation * 1000000000000ULL / 2818578888ULL;
+		FD788_ClockDeviation_W(dev->csr, dv);
 
-	return (ppt < 0) ? -value : value;
+		value = dv.deviation * 1000000000000ULL / 2818572288ULL;
+		return (ppt < 0) ? -value : value;
+	}
 }
 
 static int fd788_genlock_query(const struct forward_v4l2_genlock *gl,
@@ -912,61 +917,88 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 	FD788_SyncGenerator sg = { 0 };
 	FD788_SyncGeneratorField sgf = { 0 };
 	struct forward_pll_mode *mode = NULL;
+	bool v2 = FD788_IS_VERSION_2(v4l2->dev->fw_version);
 
 	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
 		mode = pll->ops->find_mode(pll, 0, 0, false, 148500000, false);
 		pll->ops->switch_mode(pll, mode);
-		pll->ops->select_input(pll, 1, false, false);
+		if (v2)
+			pll->ops->select_input(pll, 0, true, false);
+		else
+			pll->ops->select_input(pll, 1, false, false);
 		pll->ops->calibrate(pll);
 	} else {
-		int pll_in_freq = 0;
+		int pll_pix_freq = 0;
+		int pll_h_freq = 0;
 		FD788_Genlock gl = FD788_Genlock_R(v4l2->dev->csr);
 
+		pll_h_freq = forward_v4l2_pixel_clock(t) / t->sdi.width;
 		if (src == V4L_FORWARD_GENLOCK_SRC_ANALOG) {
-			pll_in_freq = forward_v4l2_pixel_clock(t) / t->sdi.width;
 			gl.mode = (t->sdi.mode == FORWARD_SDI_MODE_SD_SDI) ? 1 : 0;
 		} else if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) ||
 			   (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
 			if ((t->sdi.mode == FORWARD_SDI_MODE_SD_SDI) ||
 			    (t->sdi.flags & FORWARD_SDI_TIMINGS_F_ASI))
-				pll_in_freq = 6750000;
+				pll_pix_freq = v2 ? 13500000 : 6750000;
 			else if (t->sdi.mode == FORWARD_SDI_MODE_HD_SDI)
-				pll_in_freq = 74250000;
+				pll_pix_freq = 74250000;
 			else if (t->sdi.mode == FORWARD_SDI_MODE_3G_SDI)
-				pll_in_freq = 148500000;
+				pll_pix_freq = 148500000;
 			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 3 : 2;
 		}
 
-		mode = pll->ops->find_mode(pll, pll_in_freq, 0, t->sdi.m, 148500000, t->sdi.m);
+		mode = pll->ops->find_mode(pll, pll_pix_freq, pll_h_freq, t->sdi.m, 148500000,
+					   t->sdi.m);
 		if (!mode)
 			return -EINVAL;
 
 		FD788_Genlock_W(v4l2->dev->csr, gl);
 		pll->ops->switch_mode(pll, mode);
 
-		if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) || (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
-			// Hack to avoid PLL->IN->PLL loop stuck
-			FD788_VideoInCS cs;
-			int count = 0;
-
-			// Force Master clock
-			pll->ops->select_input(pll, 1, false, false);
+		if (v2) {
+			int input = 0;
+			switch (src) {
+			case V4L_FORWARD_GENLOCK_SRC_ANALOG:
+				input = 0;
+				break;
+			case V4L_FORWARD_GENLOCK_SRC_IN0:
+				input = 1;
+				break;
+			case V4L_FORWARD_GENLOCK_SRC_IN1:
+				input = 2;
+				break;
+			default:
+				input = 0;
+				break;
+			}
+			pll->ops->select_input(pll, input, false, false);
 			pll->ops->calibrate(pll);
-
-			// Wait for input
-			do {
-				msleep(100);
-				cs = FD788_VideoInCS_R(v4l2->dev->csr,
-						       (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 1 :
-											      0);
-				count++;
-			} while ((!cs.modeLocked) && (count < 100));
-
-			// Switch to input clock
-			pll->ops->select_input(pll, 0, false, true);
 		} else {
-			pll->ops->select_input(pll, 0, false, true);
-			pll->ops->calibrate(pll);
+			if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) ||
+			    (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
+				// Hack to avoid PLL->IN->PLL loop stuck
+				FD788_VideoInCS cs;
+				int count = 0;
+
+				// Force Master clock
+				pll->ops->select_input(pll, 1, false, false);
+				pll->ops->calibrate(pll);
+
+				// Wait for input
+				do {
+					msleep(100);
+					cs = FD788_VideoInCS_R(
+						v4l2->dev->csr,
+						(src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 1 : 0);
+					count++;
+				} while ((!cs.modeLocked) && (count < 100));
+
+				// Switch to input clock
+				pll->ops->select_input(pll, 0, false, true);
+			} else {
+				pll->ops->select_input(pll, 0, false, true);
+				pll->ops->calibrate(pll);
+			}
 		}
 	}
 
-- 
2.39.1


